# NGX Camera

Simple to use plug and play angular camera component.

Note: for this plugin to work you need to have secure context (`https  or localhost`) available

## Features
 - Multiple camera support
 - runs on any os that supports (web rtc/usemedia api)
 - live webcam view and image capturing
 - runs on (Chrome >53, Safari >11, Firefox >38, Edge)
 
## Demo

check out the live [demo](https://google.com)

## Usage

Standard npm install

 ```shell
 npm i ngx-camera
 ```

Import to `app.module.ts`

```typescript
@NgModule({
  ...
  imports: [
    NgxCameraModule
  ],
  ...

```

use ngx-camera component in your app
```html
<ngx-camera></ngx-camera>
``` 
use the needed inputs/outputs and events as needed 

## Inputs 

  `width: number`

  Camera area width. Default is **640**.

  `height: number`

  Camera area height. Default is **480**.


  `imageType:` [`CameraImageType`](#Enums) `| string`
  
  Define camera image type from CameraImageType enum. Default is **CameraImageType.jpeg**

  `startCam: boolean`
  
  Controls whether the camera should be initialized with life cycle hooks. If passed false you need to initialize camera in component. Default is **true**

  `imageQuality: number`

  Define camera image quality. Default is `0.9`

## Outputs/events

  `detectedDevices: EventEmitter<`[`MediaDeviceInfo`](https://developer.mozilla.org/en-US/docs/Web/API/MediaDeviceInfo)`[]>`

  event emitter for detected devices. there are cases where device name is not present.

  stream: EventEmitter<MediaDeviceInfo[]>
  event emitter for captured video stream 

  /** event emitter for errors occord at diffrent stages */
  errorStream: EventEmitter<any> = new EventEmitter();

  /** event emitter for errors occord at diffrent stages */
  imageCapture: EventEmitter<CameraImage> = new EventEmitter();

## Enums

- CameraImageType
```ts 
export enum CameraImageType {
  jpeg = 'image/jpeg',
  png = 'image/png'
}
```


